unit FichaReproductor;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, ExtCtrls, MMSystem, MPlayer, ComCtrls,
  ActnList, ImgList, ToolWin, shellapi;

type
  TfrmPrincipal = class(TForm)
    mnuMenu: TMainMenu;
    Archivo1: TMenuItem;
    OpcionAbrir: TMenuItem;
    mnuGuardar: TMenuItem;
    N1: TMenuItem;
    OpcionSalir: TMenuItem;
    Dispositivo1: TMenuItem;
    OpcionSonido: TMenuItem;
    OpcionMIDI: TMenuItem;
    OpcionVideoAVI: TMenuItem;
    OpcionAudioCD: TMenuItem;
    EventoPosicion: TTimer;
    AbrirArchivo: TOpenDialog;
    PB: TPanel;
    Control: TMediaPlayer;
    Panel2: TPanel;
    Posicion: TScrollBar;
    Ver1: TMenuItem;
    mnuControles: TMenuItem;
    mnuEncima: TMenuItem;
    N2: TMenuItem;
    Zoom1: TMenuItem;
    Aumentar1: TMenuItem;
    Disminuir1: TMenuItem;
    BE: TStatusBar;
    N3: TMenuItem;
    ActionList1: TActionList;
    ImageList1: TImageList;
    ActSonido: TAction;
    ActCDAudio: TAction;
    ActVideo: TAction;
    ActMIDI: TAction;
    ActAbrir: TAction;
    ActSalir: TAction;
    ActGuardarCambios: TAction;
    ActVerControles: TAction;
    ActVerBarra: TAction;
    bb: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ActPantallaCompleta: TAction;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    Pantallacompleta1: TMenuItem;
    ActSiempreEncima: TAction;
    Barradeherramientas1: TMenuItem;
    N4: TMenuItem;
    PopupMenu1: TPopupMenu;
    Pantallacompleta2: TMenuItem;
    Controles1: TMenuItem;
    Abrir1: TMenuItem;
    Salir1: TMenuItem;
    MIDI1: TMenuItem;
    Guardarcambios1: TMenuItem;
    CDaudio1: TMenuItem;
    Siempreencima1: TMenuItem;
    Sonido1: TMenuItem;
    Vdeo1: TMenuItem;
    N5: TMenuItem;
    Pantalla: TPanel;
    ActOcultarMenu: TAction;
    Men1: TMenuItem;
    Men2: TMenuItem;
    Barradeherramientas2: TMenuItem;
    N6: TMenuItem;
    ActVerBarraTitulo: TAction;
    Barradettulo1: TMenuItem;
    Barradettulo2: TMenuItem;
    N8: TMenuItem;
    Ver2: TMenuItem;
    Archivo2: TMenuItem;
    N7: TMenuItem;
    LWEB: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure OpcionAbrirClick(Sender: TObject);
    procedure EventoPosicionTimer(Sender: TObject);
    procedure ControlClick(Sender: TObject; Button: TMPBtnType;
      var DoDefault: Boolean);
    procedure ControlNotify(Sender: TObject);
    procedure PosicionChange(Sender: TObject);
    procedure OpcionSalirClick(Sender: TObject);
    procedure OpcionSalvarClick(Sender: TObject);
    procedure OpcionVideoAVIClick(Sender: TObject);
    procedure ActSonidoExecute(Sender: TObject);
    procedure ActCDAudioExecute(Sender: TObject);
    procedure ActVideoExecute(Sender: TObject);
    procedure ActMIDIExecute(Sender: TObject);
    procedure ActAbrirExecute(Sender: TObject);
    procedure ActSalirExecute(Sender: TObject);
    procedure ActGuardarCambiosExecute(Sender: TObject);
    procedure ActVerControlesExecute(Sender: TObject);
    procedure ActVerBarraExecute(Sender: TObject);
    procedure ActSiempreEncimaExecute(Sender: TObject);
    procedure ActPantallaCompletaExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActOcultarMenuExecute(Sender: TObject);
    procedure ActVerBarraTituloExecute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure LWEBClick2(Sender: TObject);
    procedure Aumentar1Click(Sender: TObject);
    procedure Disminuir1Click(Sender: TObject);
  private // Procedimientos y miembros internos }
    Modificando: Boolean;
    Procedure AbreArchivo(Patron: String);
    Procedure AbrirDispositivo;
    Procedure EstableceMedidas;
  public
    { Public declarations }
  end;

Const
  // Constantes con el ttulo por defecto para
  // la ventana y los filtros de seleccin de archivos
  Titulo = 'AjpdSoft - Reproductor Multimedia';
  Filtro1 = 'Todos los archivos (*.*)|*.*';
  Filtro2 = 'Archivos de audio (*.wav)|*.wav';
  Filtro3 = 'Archivos MIDI (*.mid)|*.mid';
  Filtro4 = 'Archivos de vdeo (*.avi)|*.avi';
  Filtro5 = 'Archivos mpeg|*.mpg';
  Filtro6 = 'Archivos movie|*.mov';
  Filtro7 = 'Archivos MP3|*.mp3';
var
  frmPrincipal: TfrmPrincipal;
    procedure redimensionarPantalla;
    
  implementation

{$R *.DFM}

    { Al crear la ficha comprobaremos qu
      dispositivos son los que estn disponibles,
      eliminando del men las opciones que
      correspondan }
procedure TfrmPrincipal.FormCreate(Sender: TObject);
begin
  // Usamos el TMediaPlayer para la deteccin
  With Control Do
  Begin
      // Intentamos abrir el dispositivo
      // de audio en forma de onda
    DeviceType := dtWaveAudio;
    Try
      Open;
      Close;
    Except // si no es posible, hacemos no
           // visible la opcin
      OpcionSonido.Visible := False;
    End;
      // Intentamos abrir el dispositivo
      // de reproduccin MIDI
    DeviceType := dtSequencer;
    Try
      Open;
      Close;
    Except // si no es posible, hacemos no
           // visible la opcin
      OpcionMIDI.Visible := False;
    End;

      // Intentamos abrir el dispositivo
      // de vdeo en formato AVI
    DeviceType := dtAVIVideo;
    Try
      Open;
      Close;
    Except // si no es posible, hacemos no
           // visible la opcin
      OpcionVideoAVI.Visible := False;
    End;

      // Intentamos abrir el dispositivo
      // de audio en CD
    DeviceType := dtCDAudio;
    Try
      Open;
      Close;
    Except // si no es posible, hacemos no
           // visible la opcin
      OpcionAudioCD.Visible := False;
    End;
  End;
end;

// Opcin Abrir del men Archivo
procedure TfrmPrincipal.OpcionAbrirClick(Sender: TObject);
begin
End;

    // Este procedimiento ser el encargado de presentar
    // el cuadro de dilogo para facilitar la apertura
    // de un archivo
Procedure TfrmPrincipal.AbreArchivo(Patron: String);
Begin
  With AbrirArchivo Do // Usamos el TOpenDialog
  Begin
    // Preparamos los filtros posibles
    Filter := Patron;
    // para facilitar la apertura de un archivo
    If Execute Then
    Begin
      // Pasamos el nombre al TMediaPlayer
      Control.FileName := FileName;
      Control.DeviceType := dtAutoSelect;
      // e intentamos abrir el dispositivo
      AbrirDispositivo;
    End;
  End;
end;

    { Este procedimiento se encargar de abrir los dispositivos,
      indistintamente de la opcin que se haya usado, lo que
      permite centralizar las operaciones de comprobacin y
      adecuacin de la interfaz }
Procedure TfrmPrincipal.AbrirDispositivo;
Begin
   // Si la propiedad Tag tiene algn valor es porque
   // tenemos la ficha abierta, mostrando la pantalla
   // de visualizacin de secuencias de vdeo
  If Tag <> 0 Then
  Begin
    Height := Tag; // restablecemos el alto de la ficha
    Tag := 0;
  End;
  // Desactivamos la opcin Salvar del men Archivo
  ActGuardarCambios.Enabled := False;

  With Control Do
  Try // Intentamos abrir el control
    Open;
    // Establecemos el formato de tiempo
    TimeFormat := tfMilliseconds;
    // Mostramos como ttulo de la ventana
    // el nombre del archivo, si es que existe
    If FileName = '' Then
      Caption := Titulo
    Else
    Begin
      Caption := FileName;
      // Si es una secuencia de vdeo
      If (LowerCase(ExtractFileExt(FileName)) = '.avi') or
          (LowerCase(ExtractFileExt(FileName)) = '.mpg') or
          (LowerCase(ExtractFileExt(FileName)) = '.mov') Then
      Begin
        // Establecemos la ventana de visualizacin
        // y sus dimensiones
        Display := pantalla;
        pantalla.Visible := true;
        DisplayRect := Rect(0, 0,  pantalla.Width, pantalla.Height);
        pantalla.Align := alClient;
        frmprincipal.Width := screen.Width;
        frmprincipal.Height := screen.Height;
      End
    End;
    // Llamamos a EstableceMedidas
    EstableceMedidas;
  Except // Si no se puede abrir mostramos un mensaje
    ShowMessage(ErrorMessage);
    Caption := Titulo; // Restablecemos el ttulo
  End;
End;

  // Esta funcin se encargar de ajustar los lmites
  // de la barra de desplazamiento
Procedure TfrmPrincipal.EstableceMedidas;
type
  Duracion = record
    Horas: byte;
    Minutos: byte;
    Segundos: byte;
    NoUsado: byte;
  end;
Var
  tamano : Longint;
Begin
  // La barra de desplazamiento se basar en segundos
  Posicion.Min := 0;
  Posicion.Max := Control.Length Div 1000;
  Posicion.Position := 0;
  //formato de tiempo
  control.TimeFormat := tfHMS;
  // Si el dispositivo no es un CD
  If Control.DeviceType <> dtCDAudio Then
  begin
     tamano := Control.Length;
     with duracion(tamano) do
     be.Panels[1].Text := inttostr(Horas) + ':' + inttostr(minutos) + ':' +
       inttostr(segundos);
  end
  Else // En caso de que el dispositivo sea un CD
  Begin
      be.Panels[1].Text := IntToStr(Control.Tracks) +' canciones';
      // y la longitud del disco, teniendo en cuenta
      // que sta puede pasar de la hora
      If Control.Length < 3600000 Then
        be.Panels[2].Text := IntToStr(Control.Length Div 60000) + 'min.'
      Else
        be.Panels[2].Text := '1h' +
            IntToStr((Control.Length-3600000) Div 60000)
            + 'min.';
    End;
End;

    // Cada vez que el Timer produzca un evento
procedure TfrmPrincipal.EventoPosicionTimer(Sender: TObject);
begin
  // Indicamos que la modificacin ha sido programtica
  Modificando := True;
  // y actualizamos la posicin de la barra
  Posicion.Position := Control.Position Div 1000;
  be.Panels[2].Text := inttostr(control.Tracks);
end;

  // Al pulsar sobre los botones del TMediaPlayer
procedure TfrmPrincipal.ControlClick(Sender: TObject; Button: TMPBtnType;
  var DoDefault: Boolean);
begin
  // Activamos el Timer si se ha iniciado la reproduccin
  EventoPosicion.Enabled := Button = btPlay;
  // Si se ha pulsado el botn Record, activamos la opcin
  // Salvar, para poder conservar las modificaciones
  If Button = btRecord Then
    ActGuardarCambios.Enabled := True;
end;

  // Si recibimos una notificacin del control
procedure TfrmPrincipal.ControlNotify(Sender: TObject);
begin
  // Desactivamos el timer
  EventoPosicion.Enabled := False;
end;

    // Si se ha cambiado la posicin en la barra
procedure TfrmPrincipal.PosicionChange(Sender: TObject);
begin
  // En caso de que el cambio no haya sido programtico,
  // significar que ha sido el usuario
  If Not Modificando Then
    // por lo que procedemos a modificar la posicin
    // en el dispositivo
    Control.Position := Posicion.Position * 1000
  Else // en caso contrario desactivamos el indicador
       // Modificando, puesto que ya se ha controlado
       // el evento
    Modificando := False;
end;

    // Al seleccionar la opcin Salir
procedure TfrmPrincipal.OpcionSalirClick(Sender: TObject);
begin
end;

    // Al seleccionar la opcin Salvar
procedure TfrmPrincipal.OpcionSalvarClick(Sender: TObject);
begin
end;

   // Las tres primeras opciones del men Dispositivo
   // se limitan a llamar a AbreArchivo con el filtro
   // adecuado
procedure TfrmPrincipal.OpcionVideoAVIClick(Sender: TObject);
begin
end;

  // Si se selecciona el CD
procedure TfrmPrincipal.ActSonidoExecute(Sender: TObject);
begin
  AbreArchivo(Filtro2 + '|' + filtro7 + '|' + filtro1);
end;

procedure TfrmPrincipal.ActCDAudioExecute(Sender: TObject);
begin
  // Establecemos el tipo de dispositivo
  Control.DeviceType := dtCDAudio;
  Control.FileName := '';
  AbrirDispositivo; // y lo abrimos
end;

procedure TfrmPrincipal.ActVideoExecute(Sender: TObject);
begin
  AbreArchivo(Filtro4 + '|' + filtro5 + '|' + filtro6 + '|' + filtro1);
  ActPantallaCompletaExecute(sender);
  control.Play;
end;

procedure TfrmPrincipal.ActMIDIExecute(Sender: TObject);
begin
  AbreArchivo(Filtro3 + '|' + filtro1);
end;

procedure TfrmPrincipal.ActAbrirExecute(Sender: TObject);
begin
   // Llamamos a la funcin AbreArchivo, pasando
   // como parmetros todos los filtros
  AbreArchivo(Filtro1 + '|' + Filtro2 + '|' + Filtro3 + '|' + Filtro4 +
     '|' + Filtro5 +'|' + Filtro6 +'|' + Filtro7);
end;

procedure TfrmPrincipal.ActSalirExecute(Sender: TObject);
begin
  control.Close;
  Close;
end;

procedure TfrmPrincipal.ActGuardarCambiosExecute(Sender: TObject);
begin
  Control.Save; // Usamos el mtodo Save
end;

procedure TfrmPrincipal.ActVerControlesExecute(Sender: TObject);
begin
  pb.Visible := not pb.Visible;
  mnucontroles.Checked := not mnuControles.Checked;
  redimensionarpantalla;
end;

procedure TfrmPrincipal.ActVerBarraExecute(Sender: TObject);
begin
  bb.visible := not bb.visible;
  ActVerBarra.Checked := not actverbarra.Checked;
  redimensionarpantalla;
end;

procedure TfrmPrincipal.ActSiempreEncimaExecute(Sender: TObject);
begin
  if ActSiempreEncima.Checked then
    frmPrincipal.FormStyle := fsNormal
  else
    frmPrincipal.FormStyle := fsStayOnTop;
  ActSiempreEncima.Checked := not ActSiempreEncima.Checked;
  frmprincipal.Repaint;
end;

procedure TfrmPrincipal.ActPantallaCompletaExecute(Sender: TObject);
begin
 if not ActPantallaCompleta.Checked then
 begin
  actpantallacompleta.Checked := true;
  frmprincipal.menu := nil;
  frmprincipal.BorderStyle := bsnone;
  control.Display := pantalla;
  pantalla.Refresh;
  if be.Visible then
  begin
    be.Visible := false;
    ActVerBarra.Checked := false;
  end;
  if PB.Visible then
  begin
    pb.Visible := false;
    ActVerControles.Checked := false;
  end;
  if bb.Visible then
  begin
    bb.Visible := false;
    ActVerbarra.Checked := false;
  end;
  frmPrincipal.WindowState := wsMaximized;
 end
 else
 begin
  actpantallacompleta.Checked := false;
  frmprincipal.Menu := mnumenu;
  frmprincipal.BorderStyle := bsSizeable;
  frmprincipal.WindowState := wsNormal;
  be.Visible := true;
  ActVerBarra.Checked := true;
  pb.Visible := true;
  ActVerControles.Checked := true;
  bb.Visible := true;
  ActVerbarra.Checked := true;
  redimensionarpantalla;
 end;
end;

//redimensiona la pantalla donde se muestra la imagen
procedure redimensionarPantalla();
begin
  frmprincipal.control.Display := frmprincipal.pantalla;
  frmprincipal.pantalla.Visible := true;
  frmprincipal.pantalla.Align := alClient;
  frmprincipal.control.DisplayRect := Rect(0, 0,  frmprincipal.pantalla.Width,
      frmprincipal.pantalla.Height);
end;

procedure TfrmPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    control.Stop;
    control.Close;
  except
  end;
end;

procedure TfrmPrincipal.ActOcultarMenuExecute(Sender: TObject);
begin
  if ActOcultarMenu.Checked then
    frmprincipal.menu := nil
  else
    frmprincipal.menu := mnumenu;
  actocultarmenu.Checked := not actocultarmenu.Checked;
  redimensionarpantalla;
end;

procedure TfrmPrincipal.ActVerBarraTituloExecute(Sender: TObject);
begin
  if ActVerBarraTitulo.Checked then
    frmprincipal.BorderStyle := bsNone
  else
    frmprincipal.BorderStyle := bsSizeable;
  actverbarratitulo.Checked := not ActVerBarraTitulo.Checked;
  redimensionarpantalla;
end;

procedure TfrmPrincipal.FormResize(Sender: TObject);
begin
  redimensionarPantalla;
end;

procedure TfrmPrincipal.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TfrmPrincipal.Aumentar1Click(Sender: TObject);
begin
  ShowMessage('No disponible');
end;

procedure TfrmPrincipal.Disminuir1Click(Sender: TObject);
begin
  ShowMessage('No disponible');
end;

end.
